Attribute VB_Name = "Online"
'Dieser Tip stammt von http://www.goetz-reinecke.de und
'kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'Sollten Sie Fehler entdecken oder Fragen haben, dann
'mailen Sie mir bitte unter: vb@goetz-reinecke.de
'Ansonsten viel Spa und Erfolg mit diesem Tip !

Option Explicit
'Eigene Variablen
Public StatusText As String
Public LogInTime As Date
Public LogOutTime As Date
Public AktuellesDatum As Date
Public AlterStatus As Boolean
Public StartSekunde As String

Private Declare Function RasEnumConnections Lib "RasApi32.dll" _
        Alias "RasEnumConnectionsA" (lpRasCon As Any, lpcb As _
        Long, lpcConnections As Long) As Long
        
Private Declare Function RasGetConnectStatus Lib "RasApi32.dll" _
        Alias "RasGetConnectStatusA" (ByVal hRasCon As Long, _
        lpStatus As Any) As Long

Const RAS_MaxEntryName = 256
Const RAS_MaxDeviceType = 16
Const RAS_MaxDeviceName = 32

Private Type RASType
  dwSize As Long
  hRasCon As Long
  szEntryName(RAS_MaxEntryName) As Byte
  szDeviceType(RAS_MaxDeviceType) As Byte
  szDeviceName(RAS_MaxDeviceName) As Byte
End Type

Private Type RASStatusType
  dwSize As Long
  RasConnState As Long
  dwError As Long
  szDeviceType(RAS_MaxDeviceType) As Byte
  szDeviceName(RAS_MaxDeviceName) As Byte
End Type

Public Function DFStatus() As Boolean
  Dim RAS(255) As RASType, RASStatus As RASStatusType
  Dim lg&, lpcon&, Result&
  Dim OnlineZeit As Date
     
    RAS(0).dwSize = 412
    lg = 256 * RAS(0).dwSize
    Result = RasEnumConnections(RAS(0), lg, lpcon)
    
    If lpcon = 0 Then
        StatusText = "-- Offline --" '###
        frmHauptform.txtStatus.Text = StatusText
        DFStatus = False
        If AlterStatus = False Then
            LogOutTime = Time()
            frmHauptform.Tariftimer.Enabled = False
            frmHauptform.txtlogout.Text = LogOutTime
            'Datensatz speichern
            Call frmHauptform.DatensatzSpeichern
        End If
        AlterStatus = True
    Else
        RASStatus.dwSize = 160
        Result = RasGetConnectStatus(RAS(0).hRasCon, RASStatus)
        If RASStatus.RasConnState = &H2000 Then
            StatusText = "++ Online ++"  '###
            DFStatus = True
            frmHauptform.txtStatus.Text = StatusText
            If AlterStatus = True Then
                AktuellesDatum = Date
                LogInTime = Time()
                frmHauptform.txtLogin.Text = LogInTime
                AlterStatus = False
                'Startsekunde fr Tarife ermitteln
                StartSekunde = Right(Time(), 2)
                'Zusatzkosten
                Call ZusatzkostenErmitteln
                frmHauptform.Tariftimer.Enabled = True
                'Zusatzkosten eintragen
                frmHauptform.txtKosten.Text = frmHauptform.Kosten
            End If
            OnlineZeit = Time() - LogInTime
            frmHauptform.txtonlinezeit.Text = OnlineZeit
        Else
            If AlterStatus = False Then
                StatusText = "-- abmelden --" '###
                frmHauptform.txtStatus.Text = StatusText
            Else
                StatusText = "++ anmelden ++"
                frmHauptform.txtStatus.Text = StatusText
            End If
            DFStatus = False
        End If
    End If
End Function

Public Sub ZusatzkostenErmitteln()
'Zusatzkosten ermitteln
'Verbindung mit Kosten herstellen
frmHauptform.Daten.RecordSource = "Sonderkosten"
frmHauptform.Daten.Refresh
frmHauptform.Daten.Recordset.MoveFirst
Do
    frmHauptform.Kosten = frmHauptform.Kosten + frmHauptform.Daten.Recordset.Fields("Betrag").Value
    frmHauptform.Daten.Recordset.MoveNext
Loop Until frmHauptform.Daten.Recordset.EOF
'Zusatzkosten fertig
End Sub
